<script setup lang="ts">
import { RouterLink } from 'vue-router'
import { storeToRefs } from 'pinia'
import { onClickOutside } from '@vueuse/core'
import { useCartStore } from '@/stores/cart'
import { computed, ref } from 'vue'
import CartItemTable from '@/components/cart/CartItemTable.vue'

const store = useCartStore()
const {isOpen, items, totalCartPrice} = storeToRefs(store)
const {closeCart, clearCart} = store

const target = ref(null)
onClickOutside(target, () => isOpen && closeCart())

const isEmptyCart = computed(() => items.value.length === 0)
</script>
<template>
  <!-- Start Cart Area  -->
  <div class="axil-product-cart-area axil-section-gap">
    <div class="container">
      <div class="axil-product-cart-wrap">
        <div class="product-table-heading">
          <h4 class="title">Your Cart</h4>
          <a v-if="!isEmptyCart" href="#" class="cart-clear" @click.prevent.stop="clearCart()">Clear Shoping Cart</a>
        </div>
        <div v-if="!isEmptyCart" class="table-responsive">
          <table class="table axil-product-table axil-cart-table mb--40">
            <thead>
            <tr>
              <th scope="col" class="product-remove"></th>
              <th scope="col" class="product-thumbnail">Product</th>
              <th scope="col" class="product-title"></th>
              <th scope="col" class="product-price">Price</th>
              <th scope="col" class="product-quantity">Quantity</th>
              <th scope="col" class="product-subtotal">Subtotal</th>
            </tr>
            </thead>
            <tbody>
            <CartItemTable v-for="item of items" :item="item" :key="item.selectedSize.id"/>
            </tbody>
          </table>
        </div>
        <div v-if="!isEmptyCart" class="row">
          <div class="col-xl-12 col-lg-12">
            <div class="axil-order-summery mt--10">
              <h4 class="title mb--0">Total: <span class="order-total-amount">${{ totalCartPrice }}</span></h4>
              <RouterLink
                  class="axil-btn btn-bg-primary checkout-btn"
                  :to="{ name: 'checkout' }"
                  @click="closeCart()"
              >
                Process to Checkout
              </RouterLink>
            </div>
          </div>
        </div>
        <h4 v-else class="text-center text-secondary">
          Your cart is empty
        </h4>
      </div>
    </div>
  </div>
  <!-- End Cart Area  -->
</template>
<style scoped lang="scss">
.axil-order-summery {
  display: flex;
  align-items: center;
  justify-content: space-between;

  .checkout-btn {
    width: auto;
  }
}
</style>